<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:h="http://xmlns.jcp.org/jsf/html"
      xmlns:f="http://xmlns.jcp.org/jsf/core"
      xmlns:p="http://primefaces.org/ui"
      xmlns:ui="http://java.sun.com/jsf/facelets">

<h:head>
    <title>Movie Web Project 3</title>
</h:head>
<h:body>
    <h:outputStylesheet name="css/style.css"/>

    <p:outputPanel>
        <h3>Movie Overview</h3>
        <div class="ui-g">
            <div class="ui-g-8">
                <h:form id="moviesToDisplayForm">
                    <!-- Panel used for Search Motor -->
                    <p:panelGrid columns="2"
                                 layout="grid"
                                 columnClasses="ui-grid-col-2"
                                 styleClass="customPanelGrid" contentStyleClass="ui-fluid">

                        <p:outputLabel for="@next" value="Search by year"/>
                        <p:selectOneMenu id="selectAMovieYear" onchange="submit()"
                                         valueChangeListener="#{indexBean.getListMoviesBasedOnYear}">

                            <f:selectItem itemLabel="Select One" itemValue=""/>
                            <f:selectItems value="#{indexBean.availableYearItems}"/>
                            <f:selectItem itemLabel="*" itemValue="ALL"/>
                        </p:selectOneMenu>
                    </p:panelGrid>

                    <p:dataTable id="moviesListData" var="movie" value="#{indexBean.listOfMoviesToDisplay}"
                                 widgetVar="moviesListTable">

                        <p:column headerText="Title" sortBy="#{movie.pk.title}" filterBy="#{movie.pk.title}">
                            <h:outputText value="#{movie.pk.title}"/>
                        </p:column>

                        <p:column headerText="Year">
                            <h:outputText value="#{movie.pk.year}"/>
                        </p:column>

                        <p:column headerText="Producer name" sortBy="#{movie.movieExec.name}"
                                  filterBy="#{movie.movieExec.name}">
                            <h:outputText value="#{movie.movieExec.name}"/>
                        </p:column>

                        <p:column headerText="Stars">
                            <!-- If list of Stars is NOT empty -->
                            <h:panelGroup rendered="#{not empty movie.starsIns}">
                                <ui:repeat value="#{movie.starsIns}" var="item">
                                    <h:outputText value="#{item.name}"/>
                                    <br/>
                                </ui:repeat>
                            </h:panelGroup>

                            <!-- If list of Stars is empty -->
                            <h:panelGroup rendered="#{empty movie.starsIns}">
                                <SPAN STYLE="font-weight:bold;color: red;"><h:outputText
                                        value="No available data"/></SPAN>
                            </h:panelGroup>
                        </p:column>

                        <p:column headerText="Movie details">
                            <p:commandButton value="Display" icon="pi pi-arrow-right"
                                             styleClass="ui-priority-primary"
                                             action="#{indexBean.showMovieDetails(movie.pk.title,movie.pk.year)}"
                                             update="sidebarMovie"
                                             oncomplete="PF('sidebarMovieDetails').show()">
                            </p:commandButton>
                        </p:column>
                    </p:dataTable>

                </h:form>

                <!-- Side Bar to display Movie details -->
                <p:sidebar id="sidebarMovie" widgetVar="sidebarMovieDetails" position="right" baseZIndex="10000">
                    <h2><SPAN STYLE="font-weight:bold">Title:</SPAN>
                        <SPAN STYLE="font-weight:bold;color: rgb(60, 179, 113);">
                            #{indexBean.movieDetails.pk.title}
                        </SPAN>
                    </h2>
                    <h3><SPAN STYLE="font-weight:bold">Producer:</SPAN>
                        <SPAN STYLE="font-weight:bold;color: rgb(73, 181, 255);">
                            #{indexBean.movieDetails.movieExec.name}
                        </SPAN>
                    </h3>
                    <br/>
                    <p><SPAN STYLE="font-weight:bold">Producer address:</SPAN>
                        #{indexBean.movieDetails.movieExec.address}</p>
                    <p><SPAN STYLE="font-weight:bold">Producer Certificate Nbr. :</SPAN>
                        #{indexBean.movieDetails.movieExec.certN}</p>
                    <p><SPAN STYLE="font-weight:bold">Producer Net Worth:</SPAN>
                        #{indexBean.movieDetails.movieExec.netWorth}</p>
                    <br/>
                    <p><SPAN STYLE="font-weight:bold">Year:</SPAN> #{indexBean.movieDetails.pk.year}</p>
                    <p><SPAN STYLE="font-weight:bold">Length :</SPAN> #{indexBean.movieDetails.length}</p>
                    <p><SPAN STYLE="font-weight:bold">In Color :</SPAN> #{indexBean.movieDetails.inColor}</p>
                    <p><SPAN STYLE="font-weight:bold">Studio Name :</SPAN> #{indexBean.movieDetails.studioName}</p>
                    <p><SPAN STYLE="font-weight:bold">Stars :</SPAN></p>

                    <!-- If list of Stars is NOT empty -->
                    <h:panelGroup rendered="#{not empty indexBean.movieDetails.starsIns}">
                        <ui:repeat value="#{indexBean.movieDetails.starsIns}" var="item">
                            <h:outputText value="- #{item.name}"/>
                            <br/>
                        </ui:repeat>
                    </h:panelGroup>

                    <!-- If list of Stars is empty -->
                    <h:panelGroup rendered="#{empty indexBean.movieDetails.starsIns}">
                        <SPAN STYLE="font-weight:bold;color: red;"><h:outputText value="No available data"/></SPAN>
                    </h:panelGroup>

                </p:sidebar>

                <br/>
                <br/>

                <!-- Button to display INSERT form dialog. We reinitialize listOfStarsToAdd on update -->
                <p:commandButton value="Insert new Movie" icon="pi pi-plus"
                                 styleClass="ui-priority-primary"
                                 action="#{indexBean.initListOfStarsToAdd()}"
                                 update="moviesToInsertForm:listOfStarsToAddTable"
                                 onclick="PF('insertMovieDialog').show();">
                </p:commandButton>
            </div>
        </div>

        <!-- INSERT Dialog -->
        <p:dialog header="Insert New Movie" widgetVar="insertMovieDialog" resizable="false" width="800">

            <!-- Move your form tag here to avoid closing dialog on update and with validation errors -->
            <h:form id="moviesToInsertForm">

                <h:panelGrid columns="3" cellpadding="5">
                    <p:outputLabel for="@next" value="Title : "/>
                    <p:inputText id="movieTitle" value="#{indexBean.newMovieToInsert.pk.title}"/>
                    <p:message for="@previous"/>
                    <p:outputLabel for="@next" value="Year : "/>
                    <p:inputText id="movieYear" value="#{indexBean.newMovieToInsert.pk.year}"/>
                    <p:message for="@previous"/>

                    <p:outputLabel for="@next" value="Studio name : "/>
                    <p:inputText id="movieStudioName" value="#{indexBean.newMovieToInsert.studioName}"/>
                    <p:message for="@previous"/>
                    <p:outputLabel for="@next" value="Length : "/>
                    <p:inputText id="movieLength" value="#{indexBean.newMovieToInsert.length}"/>
                    <p:message for="@previous"/>
                    <p:outputLabel for="@next" value="In color : "/>
                    <p:inputText id="movieInColor" value="#{indexBean.newMovieToInsert.inColor}"/>
                    <p:message for="@previous"/>

                    <p:outputLabel for="@next" value="Producer name : "/>
                    <p:inputText id="movieProducerName" value="#{indexBean.newMovieToInsert.movieExec.name}"/>
                    <p:message for="@previous"/>
                    <p:outputLabel for="@next" value="Producer address : "/>
                    <p:inputText id="movieProducerAddress" value="#{indexBean.newMovieToInsert.movieExec.address}"/>
                    <p:message for="@previous"/>
                    <p:outputLabel for="@next" value="Producer Certificate Nbr. : "/>
                    <p:inputText id="movieProducerCertNbr" value="#{indexBean.newMovieToInsert.movieExec.certN}"/>
                    <p:message for="@previous"/>
                    <p:outputLabel for="@next" value="Producer Net Worth: "/>
                    <p:inputText id="movieProducerNetWorth" value="#{indexBean.newMovieToInsert.movieExec.netWorth}"/>
                    <p:message for="@previous"/>
                </h:panelGrid>

                <br/>

                <!-- List of stars to add dynamically -->
                <h:panelGrid columns="3" cellpadding="5">
                    <p:outputLabel value="Stars : "/>
                    <br/>

                    <!-- Declare immediate="true" to ignore bean constraint validation on the previous Input text -->
                    <p:commandButton value="Add new Star"
                                     actionListener="#{indexBean.addInputTextForStars()}"
                                     update="listOfStarsToAddTable"
                                     icon="pi pi-plus"
                                     oncomplete="scrollToBottom()"
                                     immediate="true">
                    </p:commandButton>
                </h:panelGrid>

                <p:dataTable id="listOfStarsToAddTable" var="item" value="#{indexBean.newMovieToInsert.starsIns}"
                             emptyMessage="" scrollable="true" scrollHeight="150">
                    <p:column>
                        <p:outputLabel for="@next" value="Name : "/>
                        <p:inputText value="#{item.name}"/>
                        <p:message for="@previous"/>
                    </p:column>
                    <p:column>
                        <p:commandButton value="Delete row"
                                         action="#{indexBean.removeInputTextForStars(item)}"
                                         ajax="true"
                                         update="listOfStarsToAddTable"
                                         process="@this"
                                         styleClass="rounded-button ui-button-danger"/>
                    </p:column>
                </p:dataTable>
                <br/>
                <br/>

                <!-- To display the validation error messages, declare @form in update -->
                <p:commandButton update="moviesToDisplayForm:moviesListData @form"
                                 value="Insert"
                                 action="#{indexBean.insertNewMovie()}"
                                 oncomplete="hideDialogOnSuccess(args, 'insertMovieDialog')"
                                 icon="pi pi-plus"/>
            </h:form>
        </p:dialog>

    </p:outputPanel>

</h:body>

<script src="resources/js/common.js"></script>
</html>